<?php
namespace App\Controllers\Catalogo;

use App\Controllers\BaseResourceController;
use App\Entities\Catalogo\CatalogoLibroEntity;
use App\Models\Catalogo\CatalogoLibroModel;
use App\Models\Clientes\ClienteModel;
use Hermawan\DataTables\DataTable;

class CatalogoLibros extends BaseResourceController
{

    protected $modelName = CatalogoLibroModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Catalogo';
    protected static $singularObjectNameCc = 'CatalogoLibros';
    protected static $pluralObjectName = 'Catalogos';
    protected static $pluralObjectNameCc = 'catalogos';

    protected static $controllerSlug = 'catalogo';

    protected static $viewPath = 'themes/vuexy/form/catalogo/';

    protected $indexRoute = 'CatalogoLibrosList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('Catalogo.listingPage');
        $this->viewData['usingSweetAlert'] = true;

        // Breadcrumbs (IMN)
        $this->viewData['breadcrumb'] = [
            ['title' => lang("App.menu_catalogo"), 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_catalogo_libros"), 'route' => route_to('catalogoLibrosList'), 'active' => true]
        ];

        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('Catalogo.catalogo')]),
            'catalogoLibrosEntity' => new CatalogoLibroEntity(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewCatalogoLibrosList', $viewData);
    }


    public function add()
    {

        if ($this->request->getPost()):

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, true);

            $sanitizedData['user_created_id'] = auth()->user()->id;
            unset($sanitizedData['isk']);            

            $noException = true;
            if ($successfulResult = $this->canValidate()):

                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;

            if ($noException && $successfulResult):

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['catalogoLibrosEntity'] = isset($sanitizedData) ? new CatalogoLibroEntity($sanitizedData) : new CatalogoLibroEntity();
        $this->viewData['formAction'] = route_to('catalogoLibrosAdd');
        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('Catalogo.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');

        return $this->displayForm(__METHOD__);
    } // end function add()

    public function edit($requestedId = null)
    {

        if ($requestedId == null):
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $catalogoLibrosEntity = $this->model->find($id);

        if ($catalogoLibrosEntity == false):
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Catalogo.pais')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;

        if ($this->request->getPost()):

            $postData = $this->request->getPost();
            $sanitizedData = $this->sanitized($postData, true);
            unset($sanitizedData['isk']);
            $sanitizedData['user_update_id'] = auth()->user()->id;

            $noException = true;
            
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Catalogo.catalogo'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $catalogoLibrosEntity->fill($sanitizedData);
                $thenRedirect = false;
            endif;

            if ($noException && $successfulResult):
                $id = $catalogoLibrosEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        
        $this->viewData['catalogoLibrosEntity'] = $catalogoLibrosEntity;
        $this->viewData['formAction'] = route_to('catalogoLibrosEdit', $id);
        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('Catalogo.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable()
    {
        $reqData = $this->request->getGet();
        $start = $reqData['start'] ?? 0;
        $length = $reqData['length'] ?? 5;

        $q = $this->model->getDatatableQuery()->limit($length, $start);

        $result = DataTable::of($q)
            ->edit(
                "portada",
                function ($row, $meta) {
                    if (is_null($row->cubierta_archivo)) {
                        return '<img class="img-thumbnail" src="' . $row->portada . '" alt="Portada" style="max-height: 80px;">';

                    } else {
                        return '';
                    }
                }
            )
            ->add("actionBtns", callback: function ($q) {
                $actions = '';
                if (auth()->user()->can('catalogo.edit')) {
                    $actions .= '
                        <div class="btn-group btn-group-sm">
                            <a href="javascript:void(0);"><i class="ti ti-pencil ti-sm btn-edit mx-2" data-id="' . $q->id . '"></i></a>
                        </div>';
                }
                if (auth()->user()->can('catalogo.delete')) {
                    $actions .= '
                        <div class="btn-group btn-group-sm">
                            <a href="javascript:void(0);"><i class="ti ti-trash ti-sm btn-delete mx-2" data-id="' . $q->id . '"></i></a>
                        </div>';
                }
                return $actions;
            });

        return $result->toJson(returnAsObject: true);

    }


    /* IMN */
    public function getClientList()
    {
        $search = $this->request->getGet("q") ?? "";
        $data = (new ClienteModel())->getIdName($search);
        return $this->response->setJSON($data);

    }


}
